#!usr/bin/perl

my $target = 'entry';
my $ext = '(\d+)\.cgi';

# ====================================

my %content = (
	'entry'     => 'id,wid,subj,cat,date,auth,stat,com,tb,file,tz,add,',
	'message'   => 'id,wid,eid,stat,date,auth,host,tz,',
	'trackback' => 'id,wid,eid,stat,date,subj,name,url,tz,',
	'template'  => 'id,wid,use,name,gen,mod,info,',
	'user'      => 'id,wid,name,pass,real,disp,mail,notice,stat,order,',
);
my @ids = ();
my $dir = './' . $target . '/';
opendir(DIR, $dir);
my @filelist = readdir(DIR);
foreach my $file (@filelist)
{
	push(@ids,$1) if ($file =~ /$ext/)
}
closedir(DIR);
my $tail = $ext;
$tail =~ s/(.*)\.(\w+)/\.$2/g;
my $max = 0;
my @out = ();
my @chk = split(',',$content{$target});
@ids = sort { $a <=> $b } @ids;
foreach my $id (@ids)
{
	my $file = $dir . $id . $tail;
	print 'reading[',$id,']...';
	open(DATAIN,"<$file");
	my @data = &_decode(<DATAIN>);
	my %hash = ();
	foreach my $key ( @chk )
	{
		$hash{$key} = shift(@data);
	}
	close(DATAIN);
	push(@out,\%hash);
	$max = $id if ($id > $max);
	print 'ok',"\n";
}
print 'writing...';
&_save_list($target,$tail,\@out);
&_save_id($tail,$target,$max + 1);
print 'finished',"\n";
exit(0);

sub _save_list
{
	my $targ = shift;
	my $ext  = shift;
	my $data = shift;
	my $file = './' . $targ . $ext;
	open(LISTOUT,">$file") or die("failed to open\n");
	binmode(LISTOUT);
	foreach my $obj ( @{$data} )
	{
		print LISTOUT &_encode($obj,$targ);
	}
	close(LISTOUT);
}
sub _decode
{
	my $line = shift;
	$line =~ tr/\x0D\x0A//d;
	return map { s/\\(.)/$1 eq 't' and "\t" or $1 eq 'n' and "\n" or "$1"/eg; $_; } split("\t",$line);
}
sub _encode
{
	my ($obj,$name) = @_;
	my @data = ();
	my @elements = split(',',$content{$name});
	foreach my $elem ( @elements )
	{
		push(@data,&_linefeed($obj->{$elem}));
	}
	my @fields = map { s/\\/\\\\/g; s/\t/\\t/g; s/\n/\\n/g; $_; } @data;
	my $line = join("\t",@fields);
	return $line . "\t\n";
}
sub _linefeed
{ # unify linefeed code
	$_[0] =~ s/\x0D\x0A/\n/g;
	$_[0] =~ tr/\x0D\x0A/\n\n/;
	while ($_[0] =~ /\n$/) { $_[0] =~ s/\n$//g; }
	return($_[0]);
}
sub _save_id
{
	my $tail = shift;
	my $targ = shift;
	my $max  = shift;
	my $file = './id' . $tail;
	my $temp = './id_temp';
	open(MAXIN,"<$file");
	open(MAXOUT,">$temp");
	binmode(MAXOUT);
	while (my $line = <MAXIN>)
	{
		$line =~ tr/\x0D\x0A//d;
		my ($key,$val) = split("\t",$line,2);
		my $check = ($key eq $targ) 
			? $targ . "\t" . $max . "\n"
			: $key  . "\t" . $val . "\n";
		print MAXOUT $check;
	}
	close(MAXIN);
	close(MAXOUT);
	rename($temp,$file);
	chmod($file,0666);
	return();
}
