#!usr/bin/perl

my $ext = '(\d+)\.cgi';

# ====================================
my @all_list = (
	'amazon',    'category',  'entry',     'image',     'link',      'message',   
	'plugin',    'session',   'template',  'trackback', 'user',      'weblog',    
);
my %content = (
	'entry'     => 'id,wid,subj,cat,date,auth,stat,com,tb,file,tz,add,',
	'message'   => 'id,wid,eid,stat,date,auth,host,tz,',
	'trackback' => 'id,wid,eid,stat,date,subj,name,url,tz,',
	'template'  => 'id,wid,use,name,gen,mod,info,',
	'user'      => 'id,wid,name,pass,real,disp,mail,notice,stat,order,',
);
my %max = ();
foreach my $target ( @all_list )
{
	print 'restoring [',$target,'] **********',"\n";
	if ( defined $content{$target} )
	{
		$max{$target} = &_restore_details($target)
	}
	else
	{
		$max{$target} = &_read_index($target)
	}
}
&_save_id($tail,\%max);
print 'finished!',"\n";
exit(0);

sub _restore_details
{
	my $target = shift;
	my @ids = ();
	my $dir = './' . $target . '/';
	opendir(DIR, $dir);
	my @filelist = readdir(DIR);
	foreach my $file (@filelist)
	{
		push(@ids,$1) if ($file =~ /$ext/)
	}
	closedir(DIR);
	my $tail = $ext;
	$tail =~ s/(.*)\.(\w+)/\.$2/g;
	my $max = 0;
	my @out = ();
	my @chk = split(',',$content{$target});
	@ids = sort { $a <=> $b } @ids;
	foreach my $id (@ids)
	{
		my $file = $dir . $id . $tail;
		print 'reading[',$id,']...';
		open(DATAIN,"<$file");
		my @data = &_decode(<DATAIN>);
		my %hash = ();
		foreach my $key ( @chk )
		{
			$hash{$key} = shift(@data);
		}
		close(DATAIN);
		push(@out,\%hash);
		$max = $id if ($id > $max);
		print 'ok',"\n";
	}
	print 'writing...';
	&_save_list($target,$tail,\@out);
	return $max;
}
sub _read_index
{
	my $target = shift;
	my $tail = $ext;
	$tail =~ s/(.*)\.(\w+)$/\.$2/g;
	my $line = &_get_lastline( './' . $target . $tail );
	print $line,"\n";
	return int($line) if ($line ne '');
	return;
}
sub _get_lastline
{
	my $file = shift;
	my $bufsize = 1024;
	my $n = 1;
	my ($size, $buf, $buf_tmp, $pos);
	my @lines;
	my @tail;
	open(FILE, "< $file");
	binmode(FILE);
	$size = (-s FILE) / $bufsize;
	$pos += $size <=> ($pos = int($size));
	while ($pos--)
	{
		seek(FILE, $bufsize * $pos, 0);  
		read(FILE, $buf, $bufsize);
		$buf .= $buf_tmp;
		($buf_tmp, @lines) = $buf =~ /[^\x0D\x0A]*\x0D?\x0A?/g;
		pop(@lines);
		unshift(@tail, @lines);
		last if ( @tail >= 2 );
	}
	close(FILE);
	unshift(@tail, $buf_tmp);
	unshift(@tail); # ignore last empty line
	return $tail[-1] if ( @tail > 1 );
	return;
}

sub _save_list
{
	my $targ = shift;
	my $ext  = shift;
	my $data = shift;
	my $file = './' . $targ . $ext;
	open(LISTOUT,">$file") or die("failed to open\n");
	binmode(LISTOUT);
	foreach my $obj ( @{$data} )
	{
		print LISTOUT &_encode($obj,$targ);
	}
	close(LISTOUT);
}
sub _decode
{
	my $line = shift;
	$line =~ tr/\x0D\x0A//d;
	return map { s/\\(.)/$1 eq 't' and "\t" or $1 eq 'n' and "\n" or "$1"/eg; $_; } split("\t",$line);
}
sub _encode
{
	my ($obj,$name) = @_;
	my @data = ();
	my @elements = split(',',$content{$name});
	foreach my $elem ( @elements )
	{
		push(@data,&_linefeed($obj->{$elem}));
	}
	my @fields = map { s/\\/\\\\/g; s/\t/\\t/g; s/\n/\\n/g; $_; } @data;
	my $line = join("\t",@fields);
	return $line . "\t\n";
}
sub _linefeed
{ # unify linefeed code
	$_[0] =~ s/\x0D\x0A/\n/g;
	$_[0] =~ tr/\x0D\x0A/\n\n/;
	while ($_[0] =~ /\n$/) { $_[0] =~ s/\n$//g; }
	return($_[0]);
}
sub _save_id
{
	my $tail = shift;
	my $max  = shift;
	my $tail = $ext;
	$tail =~ s/(.*)\.(\w+)/\.$2/g;
	my $file = './id' . $tail;
	open(MAXOUT,">$file");
	binmode(MAXOUT);
	foreach my $targ ( keys %{$max} )
	{
		next if ( $max->{$targ} eq '' );
		print MAXOUT $targ,"\t",($max->{$targ} + 1),"\n";
	}
	close(MAXOUT);
	chmod($file,0666);
	return();
}
